]> git.notmuchmail.org Git - notmuch/blob - test/notmuch-test
test: allow disabling timeout with NOTMUCH_TEST_TIMEOUT=0
[notmuch] / test / notmuch-test
1 #!/usr/bin/env bash
2
3 # Run tests
4 #
5 # Copyright (c) 2005 Junio C Hamano
6 # Copyright (c) 2010 Notmuch Developers
7 #
8 # Adapted from a Makefile to a shell script by Carl Worth (2010)
9
10 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
11     echo "Error: The notmuch test suite requires a bash version >= 4.0"
12     echo "due to use of associative arrays within the test suite."
13     echo "Please try again with a newer bash (or help us fix the"
14     echo "test suite to be more portable). Thanks."
15     exit 1
16 fi
17
18 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
19 . $(dirname "$0")/export-dirs.sh || exit 1
20
21 TESTS=
22 for test in $NOTMUCH_TESTS; do
23     TESTS="$TESTS $NOTMUCH_SRCDIR/test/$test"
24 done
25
26 if [[ -z "$TESTS" ]]; then
27     TESTS="$NOTMUCH_SRCDIR/test/T[0-9][0-9][0-9]-*.sh"
28 fi
29
30 # Clean up any results from a previous run
31 rm -rf $NOTMUCH_BUILDDIR/test/test-results
32
33 # Test for timeout utility
34 if command -v timeout >/dev/null; then
35     TEST_TIMEOUT=${NOTMUCH_TEST_TIMEOUT:-2m}
36     if [ "$TEST_TIMEOUT" = 0 ]; then
37         TEST_TIMEOUT_CMD=""
38         echo "INFO: timeout disabled"
39     else
40         TEST_TIMEOUT_CMD="timeout $TEST_TIMEOUT"
41         echo "INFO: using $TEST_TIMEOUT timeout for tests"
42     fi
43 else
44     TEST_TIMEOUT_CMD=""
45 fi
46
47 trap 'e=$?; kill $!; exit $e' HUP INT TERM
48 # Run the tests
49 if test -z "$NOTMUCH_TEST_SERIALIZE" && command -v parallel >/dev/null ; then
50     test -t 1 && export COLORS_WITHOUT_TTY=t || :
51     if parallel -h | grep -q GNU ; then
52         echo "INFO: running tests with GNU parallel"
53         printf '%s\n' $TESTS | $TEST_TIMEOUT_CMD parallel
54     else
55         echo "INFO: running tests with moreutils parallel"
56         $TEST_TIMEOUT_CMD parallel -- $TESTS
57     fi
58     RES=$?
59     if [[ $RES != 0 ]]; then
60         echo "parallel test suite returned error code $RES"
61         exit $RES
62     fi
63 else
64     for test in $TESTS; do
65         $TEST_TIMEOUT_CMD $test "$@" &
66         wait $!
67         # If the test failed without producing results, then it aborted,
68         # so we should abort, too.
69         RES=$?
70         testname=$(basename $test .sh)
71         if [[ $RES != 0 && ! -e "$NOTMUCH_BUILDDIR/test/test-results/$testname" ]]; then
72             exit $RES
73         fi
74     done
75 fi
76 trap - HUP INT TERM
77
78 # Report results
79 echo
80 $NOTMUCH_SRCDIR/test/aggregate-results.sh $NOTMUCH_BUILDDIR/test/test-results/*
81 ev=$?
82
83 # Clean up
84 rm -rf $NOTMUCH_BUILDDIR/test/test-results
85
86 exit $ev